ImmutableConfiguration (Apache Commons Configuration 2.15.1 API)
Description: declaration: package: org.apache.commons.configuration2, interface: ImmutableConfiguration

Package org.apache.commons.configuration2

# Interface ImmutableConfiguration

All Known Subinterfaces:
  `Configuration`, `FileBasedConfiguration`, `HierarchicalConfiguration<T>`, `ImmutableHierarchicalConfiguration`

All Known Implementing Classes:
  `AbstractConfiguration`, `AbstractHierarchicalConfiguration`, `AbstractYAMLBasedConfiguration`, `AppletConfiguration`, `BaseConfiguration`, `BaseHierarchicalConfiguration`, `CombinedConfiguration`, `CompositeConfiguration`, `DatabaseConfiguration`, `DataConfiguration`, `DynamicCombinedConfiguration`, `EnvironmentConfiguration`, `INIConfiguration`, `JakartaServletConfiguration`, `JakartaServletContextConfiguration`, `JakartaServletFilterConfiguration`, `JakartaServletRequestConfiguration`, `JNDIConfiguration`, `JSONConfiguration`, `MapConfiguration`, `PatternSubtreeConfigurationWrapper`, `PropertiesConfiguration`, `PropertyListConfiguration`, `ServletConfiguration`, `ServletContextConfiguration`, `ServletFilterConfiguration`, `ServletRequestConfiguration`, `SubnodeConfiguration`, `SubsetConfiguration`, `SystemConfiguration`, `XMLConfiguration`, `XMLPropertiesConfiguration`, `XMLPropertyListConfiguration`, `YAMLConfiguration`

public interface ImmutableConfiguration

The main interface for accessing configuration data in a read-only fashion.

The major part of the methods defined in this interface deals with accessing properties of various data types. There is a generic `getProperty()` method, which returns the value of the queried property in its raw data type. Other getter methods try to convert this raw data type into a specific data type. If this fails, a `ConversionException` will be thrown.

For most of the property getter methods an overloaded version exists that allows to specify a default value, which will be returned if the queried property cannot be found in the configuration. The behavior of the methods that do not take a default value in case of a missing property is not defined by this interface and depends on a concrete implementation. E.g. the `AbstractConfiguration` class, which is the base class of most configuration implementations provided by this package, per default returns null if a property is not found, but provides the `setThrowExceptionOnMissing()` method, with which it can be configured to throw a `NoSuchElementException` exception in that case. (Note that getter methods for primitive types in `AbstractConfiguration` always throw an exception for missing properties because there is no way of overloading the return value.)

Since:
  2.0

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `containsKey(String key)`
  Checks if the configuration contains the specified key.
  `default boolean`
  `containsValue(Object value)`
  Tests whether this configuration contains one or more matches to this value.
  `default Set<Map.Entry<String,Object>>`
  `entrySet()`
  Returns a `Set` view of the mappings contained in this configuration.
  `default void`
  `forEach(BiConsumer<String,Object> action)`
  Performs the given action for each entry in this configuration until all entries have been processed or the action throws an exception.
  `<T> T`
  `get(Class<T> cls, String key)`
  Gets an object of the specified type associated with the given configuration key.
  `<T> T`
  `get(Class<T> cls, String key, T defaultValue)`
  Gets an object of the specified type associated with the given configuration key using a default value.
  `Object`
  `getArray(Class<?> cls, String key)`
  Gets an array of typed objects associated with the given configuration key.
  `Object`
  `getArray(Class<?> cls, String key, Object defaultValue)`
  Deprecated.
  This method should not be used any more because its signature does not allow type-safe invocations; use `get(Class, String, Object)` instead which offers the same functionality; for instance, to query for an array of ints use `int[] result = config.get(int[].class, "myArrayKey", someDefault);`.
  `BigDecimal`
  `getBigDecimal(String key)`
  Gets a `BigDecimal` associated with the given configuration key.
  `BigDecimal`
  `getBigDecimal(String key, BigDecimal defaultValue)`
  Gets a `BigDecimal` associated with the given configuration key.
  `BigInteger`
  `getBigInteger(String key)`
  Gets a `BigInteger` associated with the given configuration key.
  `BigInteger`
  `getBigInteger(String key, BigInteger defaultValue)`
  Gets a `BigInteger` associated with the given configuration key.
  `boolean`
  `getBoolean(String key)`
  Gets a boolean associated with the given configuration key.
  `boolean`
  `getBoolean(String key, boolean defaultValue)`
  Gets a boolean associated with the given configuration key.
  `Boolean`
  `getBoolean(String key, Boolean defaultValue)`
  Gets a `Boolean` associated with the given configuration key.
  `byte`
  `getByte(String key)`
  Gets a byte associated with the given configuration key.
  `byte`
  `getByte(String key, byte defaultValue)`
  Gets a byte associated with the given configuration key.
  `Byte`
  `getByte(String key, Byte defaultValue)`
  Gets a `Byte` associated with the given configuration key.
  `<T> Collection<T>`
  `getCollection(Class<T> cls, String key, Collection<T> target)`
  Gets a collection of typed objects associated with the given configuration key.
  `<T> Collection<T>`
  `getCollection(Class<T> cls, String key, Collection<T> target, Collection<T> defaultValue)`
  Gets a collection of typed objects associated with the given configuration key using the values in the specified default collection if the key does not map to an existing object.
  `double`
  `getDouble(String key)`
  Gets a double associated with the given configuration key.
  `double`
  `getDouble(String key, double defaultValue)`
  Gets a double associated with the given configuration key.
  `Double`
  `getDouble(String key, Double defaultValue)`
  Gets a `Double` associated with the given configuration key.
  `default Duration`
  `getDuration(String key)`
  Gets a `Duration` associated with the given configuration key.
  `default Duration`
  `getDuration(String key, Duration defaultValue)`
  Gets a `Duration` associated with the given configuration key.
  `String`
  `getEncodedString(String key)`
  Gets the value of a string property that is stored in encoded form in this configuration using a default `ConfigurationDecoder`.
  `String`
  `getEncodedString(String key, ConfigurationDecoder decoder)`
  Gets the value of a string property that is stored in encoded form in this configuration.
  `default <T extends Enum<T>>
  T`
  `getEnum(String key, Class<T> enumType)`
  Gets an enum associated with the given configuration key.
  `default <T extends Enum<T>>
  T`
  `getEnum(String key, Class<T> enumType, T defaultValue)`
  Gets the enum associated with the given configuration key.
  `float`
  `getFloat(String key)`
  Gets a float associated with the given configuration key.
  `float`
  `getFloat(String key, float defaultValue)`
  Gets a float associated with the given configuration key.
  `Float`
  `getFloat(String key, Float defaultValue)`
  Gets a `Float` associated with the given configuration key.
  `int`
  `getInt(String key)`
  Gets a int associated with the given configuration key.
  `int`
  `getInt(String key, int defaultValue)`
  Gets a int associated with the given configuration key.
  `Integer`
  `getInteger(String key, Integer defaultValue)`
  Gets an `Integer` associated with the given configuration key.
  `Iterator<String>`
  `getKeys()`
  Gets the list of the keys contained in the configuration.
  `Iterator<String>`
  `getKeys(String prefix)`
  Gets the list of the keys contained in the configuration that match the specified prefix.
  `default Iterator<String>`
  `getKeys(String prefix, String delimiter)`
  Gets the list of the keys contained in the configuration that match the specified prefix.
  `<T> List<T>`
  `getList(Class<T> cls, String key)`
  Gets a list of typed objects associated with the given configuration key returning a null if the key doesn't map to an existing object.
  `<T> List<T>`
  `getList(Class<T> cls, String key, List<T> defaultValue)`
  Gets a list of typed objects associated with the given configuration key returning the specified default value if the key doesn't map to an existing object.
  `List<Object>`
  `getList(String key)`
  Gets a List of the values associated with the given configuration key.
  `List<Object>`
  `getList(String key, List<?> defaultValue)`
  Gets a List of strings associated with the given configuration key.
  `long`
  `getLong(String key)`
  Gets a long associated with the given configuration key.
  `long`
  `getLong(String key, long defaultValue)`
  Gets a long associated with the given configuration key.
  `Long`
  `getLong(String key, Long defaultValue)`
  Gets a `Long` associated with the given configuration key.
  `Properties`
  `getProperties(String key)`
  Gets a list of properties associated with the given configuration key.
  `Object`
  `getProperty(String key)`
  Gets a property from the configuration.
  `short`
  `getShort(String key)`
  Gets a short associated with the given configuration key.
  `short`
  `getShort(String key, short defaultValue)`
  Gets a short associated with the given configuration key.
  `Short`
  `getShort(String key, Short defaultValue)`
  Gets a `Short` associated with the given configuration key.
  `String`
  `getString(String key)`
  Gets a string associated with the given configuration key.
  `String`
  `getString(String key, String defaultValue)`
  Gets a string associated with the given configuration key.
  `String[]`
  `getStringArray(String key)`
  Gets an array of strings associated with the given configuration key.
  `ImmutableConfiguration`
  `immutableSubset(String prefix)`
  Return a decorator immutable Configuration containing every key from the current Configuration that starts with the specified prefix.
  `boolean`
  `isEmpty()`
  Checks if the configuration is empty.
  `int`
  `size()`
  Returns the number of keys stored in this configuration.

- ## Method Details

  - ### containsKey

    boolean containsKey(String key)
    Checks if the configuration contains the specified key.
    Parameters:
      `key` - the key whose presence in this configuration is to be tested
    Returns:
      `true` if the configuration contains a value for this key, `false` otherwise

  - ### containsValue

    default boolean containsValue(Object value)
    Tests whether this configuration contains one or more matches to this value. This operation stops at first match but may be more expensive than the `containsKey` method.
    Parameters:
      `value` - value whose presence in this configuration is to be tested
    Returns:
      `true` if this configuration maps one or more keys to the specified value, false otherwise.
    Since:
      2.11.0

  - ### entrySet

    default Set<Map.Entry<String,Object>> entrySet()
    Returns a `Set` view of the mappings contained in this configuration.
    Returns:
      a set view of the mappings contained in this configuration.
    Since:
      2.13.0

  - ### forEach

    default void forEach(BiConsumer<String,Object> action)
    Performs the given action for each entry in this configuration until all entries have been processed or the action throws an exception. Unless otherwise specified by the implementing class, actions are performed in the order of entry set iteration (if an iteration order is specified.) Exceptions thrown by the action are relayed to the caller.

         for (Map.Entry<K, V> entry : map.entrySet())
             action.accept(entry.getKey(), entry.getValue());

    The default implementation makes no guarantees about synchronization or atomicity properties of this method. Any implementation providing atomicity guarantees must override this method and document its concurrency properties.

    Parameters:
      `action` - The action to be performed for each entry.
    Throws:
      `NullPointerException` - if the specified action is null.
      `ConcurrentModificationException` - if an entry is found to be removed during iteration.
    Since:
      2.13.0

  - ### get

    <T> T get(Class<T> cls, String key)
    Gets an object of the specified type associated with the given configuration key. If the key doesn't map to an existing object, the method returns null unless `AbstractConfiguration.isThrowExceptionOnMissing()` is set to `true`.
    Type Parameters:
      `T` - the target type of the value
    Parameters:
      `cls` - the target class of the value
      `key` - the key of the value
    Returns:
      the value of the requested type for the key
    Throws:
      `NoSuchElementException` - if the key doesn't map to an existing object and `throwExceptionOnMissing=true`
      `ConversionException` - if the value is not compatible with the requested type
    Since:
      2.0

  - ### get

    <T> T get(Class<T> cls, String key, T defaultValue)
    Gets an object of the specified type associated with the given configuration key using a default value. If the key doesn't map to an existing object, the default value is returned.
    Type Parameters:
      `T` - the target type of the value
    Parameters:
      `cls` - the target class of the value
      `key` - the key of the value
      `defaultValue` - the default value
    Returns:
      the value of the requested type for the key
    Throws:
      `ConversionException` - if the value is not compatible with the requested type
    Since:
      2.0

  - ### getArray

    Object getArray(Class<?> cls, String key)
    Gets an array of typed objects associated with the given configuration key. If the key doesn't map to an existing object, an empty list is returned.
    Parameters:
      `cls` - the type expected for the elements of the array
      `key` - The configuration key.
    Returns:
      The associated array if the key is found, and the value compatible with the type specified.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not compatible with a list of the specified class.
    Since:
      2.0

  - ### getArray

    @Deprecated Object getArray(Class<?> cls, String key, Object defaultValue)
    Deprecated.
    This method should not be used any more because its signature does not allow type-safe invocations; use `get(Class, String, Object)` instead which offers the same functionality; for instance, to query for an array of ints use `int[] result = config.get(int[].class, "myArrayKey", someDefault);`.
    Gets an array of typed objects associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `cls` - the type expected for the elements of the array
      `key` - the configuration key.
      `defaultValue` - the default value
    Returns:
      The associated array if the key is found, and the value compatible with the type specified.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not compatible with an array of the specified class.
      `IllegalArgumentException` - if the default value is not an array of the specified type
    Since:
      2.0

  - ### getBigDecimal

    BigDecimal getBigDecimal(String key)
    Gets a `BigDecimal` associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated BigDecimal if key is found and has valid format

  - ### getBigDecimal

    BigDecimal getBigDecimal(String key, BigDecimal defaultValue)
    Gets a `BigDecimal` associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated BigDecimal if key is found and has valid format, default value otherwise.

  - ### getBigInteger

    BigInteger getBigInteger(String key)
    Gets a `BigInteger` associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated BigInteger if key is found and has valid format

  - ### getBigInteger

    BigInteger getBigInteger(String key, BigInteger defaultValue)
    Gets a `BigInteger` associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated BigInteger if key is found and has valid format, default value otherwise.

  - ### getBoolean

    boolean getBoolean(String key)
    Gets a boolean associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated boolean.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Boolean.

  - ### getBoolean

    boolean getBoolean(String key, boolean defaultValue)
    Gets a boolean associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated boolean.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Boolean.

  - ### getBoolean

    Boolean getBoolean(String key, Boolean defaultValue)
    Gets a `Boolean` associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated boolean if key is found and has valid format, default value otherwise.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Boolean.

  - ### getByte

    byte getByte(String key)
    Gets a byte associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated byte.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Byte.

  - ### getByte

    byte getByte(String key, byte defaultValue)
    Gets a byte associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated byte.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Byte.

  - ### getByte

    Byte getByte(String key, Byte defaultValue)
    Gets a `Byte` associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated byte if key is found and has valid format, default value otherwise.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Byte.

  - ### getCollection

    <T> Collection<T> getCollection(Class<T> cls, String key, Collection<T> target)
    Gets a collection of typed objects associated with the given configuration key. This method works like `getCollection(Class, String, Collection, Collection)` passing in null as default value.
    Type Parameters:
      `T` - the element type of the result list
    Parameters:
      `cls` - the element class of the result list
      `key` - the configuration key
      `target` - the target collection (may be null)
    Returns:
      the collection to which data was added
    Throws:
      `ConversionException` - if the conversion is not possible
    Since:
      2.0

  - ### getCollection

    <T> Collection<T> getCollection(Class<T> cls, String key, Collection<T> target, Collection<T> defaultValue)
    Gets a collection of typed objects associated with the given configuration key using the values in the specified default collection if the key does not map to an existing object. This method is similar to `getList()`, however, it allows specifying a target collection. Results are added to this collection. This is useful if the data retrieved should be added to a specific kind of collection, for example a set to remove duplicates. The return value is as follows:
    - If the key does not map to an existing object and the default value is null, the method returns null.
    - If the target collection is not null and data has been added (either from the resolved property value or from the default collection), the target collection is returned.
    - If the target collection is null and data has been added (either from the resolved property value or from the default collection), return value is the target collection created by this method.
    Type Parameters:
      `T` - the element type of the result list
    Parameters:
      `cls` - the element class of the result list
      `key` - the configuration key
      `target` - the target collection (may be null)
      `defaultValue` - the default value (may be null)
    Returns:
      the collection to which data was added
    Throws:
      `ConversionException` - if the conversion is not possible
    Since:
      2.0

  - ### getDouble

    double getDouble(String key)
    Gets a double associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated double.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Double.

  - ### getDouble

    double getDouble(String key, double defaultValue)
    Gets a double associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated double.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Double.

  - ### getDouble

    Double getDouble(String key, Double defaultValue)
    Gets a `Double` associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated double if key is found and has valid format, default value otherwise.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Double.

  - ### getDuration

    default Duration getDuration(String key)
    Gets a `Duration` associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated Duration if key is found and has valid format, default value otherwise.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Duration.
    Since:
      2.8.0

  - ### getDuration

    default Duration getDuration(String key, Duration defaultValue)
    Gets a `Duration` associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated Duration if key is found and has valid format, default value otherwise.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Duration.
    Since:
      2.8.0

  - ### getEncodedString

    String getEncodedString(String key)
    Gets the value of a string property that is stored in encoded form in this configuration using a default `ConfigurationDecoder`. This method works like the method with the same name, but it uses a default `ConfigurationDecoder` associated with this configuration. It depends on a specific implementation how this default decoder is obtained.
    Parameters:
      `key` - the configuration key
    Returns:
      the plain string value of the specified encoded property

  - ### getEncodedString

    String getEncodedString(String key, ConfigurationDecoder decoder)
    Gets the value of a string property that is stored in encoded form in this configuration. This method obtains the value of the string property identified by the given key. This value is then passed to the provided `ConfigurationDecoder`. The value returned by the `ConfigurationDecoder` is passed to the caller. If the key is not associated with a value, the decoder is not invoked; depending on this configuration's settings either null is returned or an exception is thrown.
    Parameters:
      `key` - the configuration key
      `decoder` - the `ConfigurationDecoder` (must not be null)
    Returns:
      the plain string value of the specified encoded property
    Throws:
      `IllegalArgumentException` - if a null decoder is passed

  - ### getEnum

    default <T extends Enum<T>> T getEnum(String key, Class<T> enumType)
    Gets an enum associated with the given configuration key.
    Type Parameters:
      `T` - The enum type whose constant is to be returned.
    Parameters:
      `key` - The configuration key.
      `enumType` - the `Class` object of the enum type from which to return a constant
    Returns:
      The associated enum.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a String.
    Since:
      2.8.0

  - ### getEnum

    default <T extends Enum<T>> T getEnum(String key, Class<T> enumType, T defaultValue)
    Gets the enum associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Type Parameters:
      `T` - The enum type whose constant is to be returned.
    Parameters:
      `key` - The configuration key.
      `enumType` - the `Class` object of the enum type from which to return a constant
      `defaultValue` - The default value.
    Returns:
      The associated enum if key is found and has valid format, default value otherwise.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Enum.
    Since:
      2.8.0

  - ### getFloat

    float getFloat(String key)
    Gets a float associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated float.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Float.

  - ### getFloat

    float getFloat(String key, float defaultValue)
    Gets a float associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated float.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Float.

  - ### getFloat

    Float getFloat(String key, Float defaultValue)
    Gets a `Float` associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated float if key is found and has valid format, default value otherwise.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Float.

  - ### getInt

    int getInt(String key)
    Gets a int associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated int.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Integer.

  - ### getInt

    int getInt(String key, int defaultValue)
    Gets a int associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated int.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Integer.

  - ### getInteger

    Integer getInteger(String key, Integer defaultValue)
    Gets an `Integer` associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated int if key is found and has valid format, default value otherwise.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Integer.

  - ### getKeys

    Iterator<String> getKeys()
    Gets the list of the keys contained in the configuration. The returned iterator can be used to obtain all defined keys. It does not allow removing elements from this configuration via its `remove()` method. Note that the keys of this configuration are returned in a form, so that they can be directly evaluated; escaping of special characters (if necessary) has already been performed.
    Returns:
      An Iterator.

  - ### getKeys

    Iterator<String> getKeys(String prefix)
    Gets the list of the keys contained in the configuration that match the specified prefix.

    For instance, if the configuration contains the following keys:

         db.user, db.pwd, db.url, window.xpos, window.ypos

    The expression `getKeys("db")` will return:

         db.user, db.pwd, db.url

    Note that the prefix itself is included in the result set if there is a matching key. The exact behavior - how the prefix is actually interpreted - depends on a concrete implementation.

    Parameters:
      `prefix` - The prefix to test against.
    Returns:
      An Iterator of keys that match the prefix.
    See Also:
      - `getKeys()`

  - ### getKeys

    default Iterator<String> getKeys(String prefix, String delimiter)
    Gets the list of the keys contained in the configuration that match the specified prefix.

    For instance, if the configuration contains the following keys:

         db@user, db@pwd, db@url, window.xpos, window.ypos

    The expression `getKeys("db","@")` will return:

         db@user, db@pwd, db@url

    Note that the prefix itself is included in the result set if there is a matching key. The exact behavior - how the prefix is actually interpreted - depends on a concrete implementation.

    Parameters:
      `prefix` - The prefix to test against.
      `delimiter` - The prefix delimiter.
    Returns:
      An Iterator of keys that match the prefix.
    Since:
      2.10.0
    See Also:
      - `getKeys()`

  - ### getList

    <T> List<T> getList(Class<T> cls, String key)
    Gets a list of typed objects associated with the given configuration key returning a null if the key doesn't map to an existing object.
    Type Parameters:
      `T` - the type expected for the elements of the list
    Parameters:
      `cls` - the class expected for the elements of the list
      `key` - The configuration key.
    Returns:
      The associated list if the key is found.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not compatible with a list of the specified class.
    Since:
      2.0

  - ### getList

    <T> List<T> getList(Class<T> cls, String key, List<T> defaultValue)
    Gets a list of typed objects associated with the given configuration key returning the specified default value if the key doesn't map to an existing object. This method recursively retrieves all values stored for the passed in key, i.e. if one of these values is again a complex object like an array or a collection (which may be the case for some concrete subclasses), all values are extracted and added to the resulting list - performing a type conversion if necessary.
    Type Parameters:
      `T` - the type expected for the elements of the list
    Parameters:
      `cls` - the class expected for the elements of the list
      `key` - the configuration key.
      `defaultValue` - the default value.
    Returns:
      The associated List.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not compatible with a list of the specified class.
    Since:
      2.0

  - ### getList

    List<Object> getList(String key)
    Gets a List of the values associated with the given configuration key. This method is different from the generic `getList()` method in that it does not recursively obtain all values stored for the specified property key. Rather, only the first level of the hierarchy is processed. So the resulting list may contain complex objects like arrays or collections - depending on the storage structure used by a concrete subclass. If the key doesn't map to an existing object, an empty List is returned.
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated List.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a List.

  - ### getList

    List<Object> getList(String key, List<?> defaultValue)
    Gets a List of strings associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated List of strings.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a List.
    See Also:
      - `getList(Class, String, List)`

  - ### getLong

    long getLong(String key)
    Gets a long associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated long.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Long.

  - ### getLong

    long getLong(String key, long defaultValue)
    Gets a long associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated long.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Long.

  - ### getLong

    Long getLong(String key, Long defaultValue)
    Gets a `Long` associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated long if key is found and has valid format, default value otherwise.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Long.

  - ### getProperties

    Properties getProperties(String key)
    Gets a list of properties associated with the given configuration key. This method expects the given key to have an arbitrary number of String values, each of which is of the form `key=value`. These strings are split at the equals sign, and the key parts will become keys of the returned `Properties` object, the value parts become values.
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated properties if key is found.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a String/List.
      `IllegalArgumentException` - if one of the tokens is malformed (does not contain an equals sign).

  - ### getProperty

    Object getProperty(String key)
    Gets a property from the configuration. This is the most basic get method for retrieving values of properties. In a typical implementation of the `Configuration` interface the other get methods (that return specific data types) will internally make use of this method. On this level variable substitution is not yet performed. The returned object is an internal representation of the property value for the passed in key. It is owned by the `Configuration` object. So a caller should not modify this object. It cannot be guaranteed that this object will stay constant over time (i.e. further update operations on the configuration may change its internal state).
    Parameters:
      `key` - property to retrieve
    Returns:
      the value to which this configuration maps the specified key, or null if the configuration contains no mapping for this key.

  - ### getShort

    short getShort(String key)
    Gets a short associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated short.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Short.

  - ### getShort

    short getShort(String key, short defaultValue)
    Gets a short associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated short.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Short.

  - ### getShort

    Short getShort(String key, Short defaultValue)
    Gets a `Short` associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated short if key is found and has valid format, default value otherwise.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a Short.

  - ### getString

    String getString(String key)
    Gets a string associated with the given configuration key.
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated string.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a String.

  - ### getString

    String getString(String key, String defaultValue)
    Gets a string associated with the given configuration key. If the key doesn't map to an existing object, the default value is returned.
    Parameters:
      `key` - The configuration key.
      `defaultValue` - The default value.
    Returns:
      The associated string if key is found and has valid format, default value otherwise.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a String.

  - ### getStringArray

    String[] getStringArray(String key)
    Gets an array of strings associated with the given configuration key. If the key doesn't map to an existing object an empty array is returned
    Parameters:
      `key` - The configuration key.
    Returns:
      The associated string array if key is found.
    Throws:
      `ConversionException` - is thrown if the key maps to an object that is not a String/List of Strings.

  - ### immutableSubset

    ImmutableConfiguration immutableSubset(String prefix)
    Return a decorator immutable Configuration containing every key from the current Configuration that starts with the specified prefix. The prefix is removed from the keys in the subset. For example, if the configuration contains the following properties:

            prefix.number = 1
            prefix.string = Apache
            prefixed.foo = bar
            prefix = Jakarta

    the immutable Configuration returned by `subset("prefix")` will contain the properties:

            number = 1
            string = Apache
            = Jakarta

    (The key for the value "Jakarta" is an empty string)
    Parameters:
      `prefix` - The prefix used to select the properties.
    Returns:
      a subset immutable configuration

  - ### isEmpty

    boolean isEmpty()
    Checks if the configuration is empty.
    Returns:
      `true` if the configuration contains no property, `false` otherwise.

  - ### size

    int size()
    Returns the number of keys stored in this configuration. Note that a concrete implementation is not guaranteed to be efficient; for some implementations it may be expensive to determine the size. Especially, if you just want to check whether a configuration is empty, it is preferable to use the `isEmpty()` method.
    Returns:
      the number of keys stored in this configuration